# __init__.py
from os import chdir, getcwd, getenv
from os.path import abspath, dirname, exists as _exists,expanduser
import os
from envoy import run
from its import linux, osx, windows
from osascript import sudo

exists=os.path.exists("setup.py")


def fullname(f="setup.py"):
    """python setup.py --fullname"""
    f=abspath(expanduser(f))
    if _exists(f):
        return run("python %s --fullname" % f).std_out.splitlines()[-1]

def name():
    """python setup.py --name"""
    setup=abspath(expanduser("setup.py"))
    if _exists(setup):
        return run("python setup.py --name").std_out.splitlines()[-1]

def version():
    """python setup.py --version"""
    setup=abspath(expanduser("setup.py"))
    if _exists(setup):
        return run("python setup.py --version").std_out.splitlines()[-1]

def clean(f="setup.py"):
    """python setup.py clean --all"""
    f=abspath(expanduser(f))
    pwd = getcwd()
    if _exists(f):
        try:
            chdir(dirname(f))
            command="python setup.py clean --all"
            run(command)
            chdir(pwd)
        except Exception,e:
            chdir(pwd)
            raise Exception(str(e))

def check(bin="python",f="setup.py"):
    """return True if "python setup.py check" succesfull"""
    f=abspath(expanduser(f))
    if _exists(f):
        pwd = getcwd()
        # change current dir to testing relative paths
        chdir(getenv("HOME")) 
        try:
            command="%s %s check" % (bin,f)
            run(command)
            chdir(pwd) # return current dir
        except Exception, e:
            chdir(pwd) # return current dir
            raise Exception(str(e))
    return True

def install(bin="python",f="setup.py"):
    """python setup.py install"""
    f=abspath(expanduser(f))
    pwd = getcwd()
    if _exists(f):
        try:
            clean(f) # clean first
            chdir(dirname(f))
            command="%s setup.py install" % bin
            if linux:
                run("sudo "+command)
                # idk how sudo in linux, use Mac OS ;)
            if osx:
                sudo(command)
            if windows:
                run(command)
            chdir(pwd)
            return True
        except Exception:
            chdir(pwd)
            return False

def register(f="setup.py"):
    """python setup.py register"""
    f=abspath(expanduser(f))
    if _exists(f):
        r=run("python %s register" % f).std_out
        if not r.find("Server response (200): OK")>0:
            raise Exception(r)

def upload(f="setup.py",distribution="sdist"):
    """python setup.py distribution upload"""
    f=abspath(expanduser(f))
    pwd = getcwd()
    if _exists(f):
        try:
            chdir(dirname(f))
            register(f)
            command="python setup.py %s upload" % distribution
            r=sudo(command)
            chdir(pwd)
            if r.find("Server response (200): OK")>0:
                return True
            if r.find("you should create a new release")>0:
                raise Exception(r.splitlines()[-2:])
        except Exception,e:
            chdir(pwd)
            print "exception:"
            print str(e)
            raise Exception(str(e))
        raise Exception(r)

#def bdist_upload(f="setup.py"):
    #return upload(f,"bdist")

def sdist_upload(f="setup.py"):
    """python setup.py %s upload"""
    return upload(f,"sdist")

upload("/Users/nordmenss/git/setuppy/setup.py")